import random
from BinomialHeap import BinomialHeap

#TEST INSERT
print("Test exercise 9.1)");
testA = True;
heap = BinomialHeap();
#Test 1
if (heap.__str__()!="empty heap"):
    print("Fehler: Leerer Heap");
    testA = False;

heap.insert(0);
#Test 2
if (heap.__str__()!="[(0)] "):
    print("Fehler Test 2a");
    testA = False;
        
heap.insert(0);
heap.insert(1);
heap.insert(2);

#Test 3
if (heap.__str__()!="[(0)[(0)][(1)[(2)]]] "):
    print("Fehler Test 3a");
    testA = False;
        
heap.insert(3);
heap.insert(4);
heap.insert(5);
heap.insert(6);
heap.insert(0);
        
#Test 4
if heap.__str__()!="[(0)] [(0)[(0)][(1)[(2)]][(3)[(4)][(5)[(6)]]]] ":
    print("Fehler Test 4a");
    testA = False;
    
heap.insert(0);
heap.insert(1);
heap.insert(2);
heap.insert(3);
heap.insert(4);
heap.insert(5);
heap.insert(6);
        
        
#Test 5
if (heap.__str__()!="[(0)[(0)][(1)[(2)]][(3)[(4)][(5)[(6)]]][(0)[(0)][(1)[(2)]][(3)[(4)][(5)[(6)]]]]] "):
    print("Fehler Test 5a");
    testA = False;

if (testA): print("OK");


#----------------------------------------------------------------------------
#TEST DELETE MIN
#----------------------------------------------------------------------------
print("Test exercise 9.2)");
testB = True;
heap = BinomialHeap();
heap.insert(42);
if (heap.delete_min()!=42):
    testB = False;
    print("Fehler Test 1b");

heap.insert(3);
heap.insert(2);
heap.insert(3);
heap.insert(2);
heap.insert(1);
heap.insert(5);
heap.insert(6);
heap.insert(7);
heap.insert(10);
heap.insert(0);

#Test 2
if (heap.delete_min()!=0 or heap.delete_min()!=1 or heap.delete_min()!=2 or heap.delete_min()!=2 or heap.delete_min()!=3 or heap.delete_min()!=3):
    testB = False;
    print("Fehler Test 2b");

#Test 3
if (heap.__str__()!="[(5)[(10)][(6)[(7)]]] "):
    print("Fehler Test 2b");
    testB = False;

heap = BinomialHeap();
for i in range(10000):
    heap.insert(random.randint(0,4000));

last = -1;
for i in range(10000):
    current = heap.delete_min();
    if (current < last):
        print("Fehler Test 3b");
        testB = False;
    last = current;

heap = BinomialHeap();
heap.insert(10);
heap.delete_min();
errorFound = False;
try:
    heap.delete_min();
except IndexError:
    errorFound = True;
if not errorFound:
    print("Fehler: DeleteMin bei leeren Heaps");
    testB = False;

if testB: print("OK");

#----------------------------------------------------------------------------
#TEST DECREASE KEY
#----------------------------------------------------------------------------
print("Test exercise 9.3)");    
testC = True;
heap = BinomialHeap();
node = heap.insert(42);
heap.decrease_key(node, 10);
if heap.delete_min()!=10:
    testC = False;
    print("Fehler Test 1c");
node = heap.insert(42);
error_found = False;
try:
    heap.decrease_key(node, 44);
except ValueError:
    error_found = True;
if not error_found:
    print("Fehler bei increaseKey nicht gefunden");
    testC = False;

heap = BinomialHeap();
node3 = heap.insert(3);
heap.insert(10);
heap.insert(1);
heap.insert(0);
heap.insert(4);
heap.insert(6);
heap.insert(14);
node16 = heap.insert(16);
node = heap.insert(15);
heap.insert(8);
heap.insert(2);
heap.insert(5);
r_node = heap.insert(20);

if heap.__str__()!="[(20)] [(2)[(5)][(8)[(15)]]] [(0)[(1)][(3)[(10)]][(4)[(6)][(14)[(16)]]]] " :
    testC = False;
    print("Fehler Test 1c");

heap.decrease_key(node, 6);
heap.decrease_key(node16, 3);
heap.decrease_key(r_node, -1);
heap.decrease_key(node3, 2);
if heap.__str__()!="[(-1)] [(2)[(5)][(6)[(8)]]] [(0)[(1)][(2)[(10)]][(3)[(6)][(4)[(14)]]]] " :
    testC = False;
    print("Fehler Test 2c");

if testC: print("OK");

#----------------------------------------------------------------------------
#TEST DELETE
#----------------------------------------------------------------------------
print("Test exercise 9.4)");
testD = True;
heap = BinomialHeap();
node = heap.insert(9);
heap.insert(2);
heap.insert(3);
node2 = heap.insert(4);
heap.insert(7);
heap.insert(6);
heap.insert(14);

heap.delete(node);
heap.delete(node2);

heap.insert(1);
heap.insert(5);

#Test 2
if (heap.delete_min()!=1 or heap.delete_min()!=2 or heap.delete_min()!=3 or heap.delete_min()!=5 or heap.delete_min()!=6 or heap.delete_min()!=7 or heap.delete_min()!=14):
    testD = False;
    print("Fehler Test 1d");
    
if (testD): print("OK");

#----------------------------------------------------------------------------
#TEST SOME CRAZY OPERATIONS
#----------------------------------------------------------------------------
print("AdditionalTests");
testE = True;
heap = BinomialHeap();
node = heap.insert(9);
node = heap.insert(2);
node = heap.insert(1);
node = heap.insert(0);
node = heap.insert(10);
node = heap.insert(7);
node = heap.insert(6);
if (heap.__str__()!="[(6)] [(7)[(10)]] [(0)[(1)][(2)[(9)]]] "):
    testE=False;
    print("Fehler Test 1e");
node = heap.insert(4);
node = heap.insert(3);
node = heap.insert(15);
node = heap.insert(17);
node = heap.insert(5);
node = heap.insert(27);
node = heap.insert(18);
node = heap.insert(20);
if (heap.__str__()!="[(20)] [(18)[(27)]] [(3)[(15)][(5)[(17)]]] [(0)[(1)][(2)[(9)]][(4)[(6)][(7)[(10)]]]] "):
    testE=False;
    print("Fehler Test 2e");
heap.delete_min();
if (heap.__str__()!="[(18)[(27)]] [(3)[(15)][(5)[(17)]]] [(1)[(20)][(2)[(9)]][(4)[(6)][(7)[(10)]]]] " and
    heap.__str__()!="[(18)[(27)]] [(4)[(6)][(7)[(10)]]] [(1)[(20)][(2)[(9)]][(3)[(15)][(5)[(17)]]]] " and
    heap.__str__()!="[(18)[(27)]] [(1)[(20)][(2)[(9)]]] [(3)[(15)][(5)[(17)]][(4)[(6)][(7)[(10)]]]] " and
    heap.__str__()!="[(1)[(20)]] [(3)[(15)][(5)[(17)]]] [(2)[(9)][(18)[(27)]][(4)[(6)][(7)[(10)]]]] " and
    heap.__str__()!="[(1)[(20)]] [(2)[(9)][(18)[(27)]]] [(3)[(15)][(5)[(17)]][(4)[(6)][(7)[(10)]]]] " and
    heap.__str__()!="[(1)[(20)]] [(4)[(6)][(7)[(10)]]] [(2)[(9)][(18)[(27)]][(3)[(15)][(5)[(17)]]]] " and
    heap.__str__()!="[(2)[(9)]] [(3)[(15)][(5)[(17)]]] [(1)[(20)][(18)[(27)]][(4)[(6)][(7)[(10)]]]] " and
    heap.__str__()!="[(2)[(9)]] [(1)[(20)][(18)[(27)]]] [(3)[(15)][(5)[(17)]][(4)[(6)][(7)[(10)]]]] " and
    heap.__str__()!="[(2)[(9)]] [(4)[(6)][(7)[(10)]]] [(1)[(20)][(18)[(27)]][(3)[(15)][(5)[(17)]]]] "):
    testE=False;
    print("Fehler Test 3e");
#ParentProblem
heap = BinomialHeap();
heap.insert(2);
node = heap.insert(4);
heap.delete_min();
heap.decrease_key(node, 1);
if (heap.__str__()!="[(1)] "):
    testE=False;
    print("Fehler Test 4e");
if (testE): print("OK");